using System;
using System.Collections.Generic;
using System.Threading.Tasks;


class Program : System.Windows.Forms.Form
{
	Dictionary<System.Windows.Forms.Keys, bool>	mKey = new Dictionary<System.Windows.Forms.Keys, bool>();

	TUGames1.Program		mProgM;
	TUGames1.Attrib			mAtrbM;
	TUGames1.Program		mProgN;
	TUGames1.Attrib			mAtrbN;
	TUGames1.Program		mProgL;
	TUGames1.Attrib			mAtrbL;
	TUGames1.PrimitiveEx	mPriL;
	TUGames1.Model			mModel;
	bool					mInit;
	float					mAngleH = 0.0f;
	float					mAngleV = 0.0f;
	float					mLiDirH = 0.0f;
	float					mLiDirV = 0.0f;
	float					mZoom = 5.0f;
	bool					mNormal = false;

	Program()
	{
		SetStyle( System.Windows.Forms.ControlStyles.Opaque, true );	//	ちらつき防止
		ClientSize = new System.Drawing.Size( 480, 480 );
		GL.Init( Handle );
		mProgM = TUGames1.Program.Create( TUGames1.Program.Format.T2F_C4UB_V3F );
		mAtrbM = mProgM.createAttrib();
		mProgN = TUGames1.Program.Create( TUGames1.Program.Format.T2F_C4UB_N3F_V3F );
		mAtrbN = mProgN.createAttrib();
		mProgL = TUGames1.Program.Create( TUGames1.Program.Format.C4UB_V3F );
		mAtrbL = mProgL.createAttrib();

TUGames1.Model.ToBinFromIni( TUGames1.UT.ExecutableDirectory() + "/assets/house1.ini" );
		mModel = TUGames1.Model.CreateFromIni( TUGames1.UT.ExecutableDirectory() + "/assets/house1.ini" );

		mPriL = new TUGames1.PrimitiveEx();
		mPriL.mMode = GL.LINES;
		mPriL.createBufferPosition( new float[]{
			-8.0f, 0.0f, 0.0f,
			 8.0f, 0.0f, 0.0f,

			 0.0f, -8.0f, 0.0f,
			 0.0f,  8.0f, 0.0f,

			 0.0f,  0.0f, -8.0f,
			 0.0f,  0.0f,  8.0f,
		} );
		mPriL.createBufferIndices( new ushort[]{
			0, 1,
			2, 3,
			4, 5,
		} );
		mPriL.createBufferColor();
		mPriL.bufferSubColor(  0, new uint[]{
			0xff0000ff, 0xff0000ff,
			0xff00ff00, 0xff00ff00,
			0xffff0000, 0xffff0000,
		} );

		mKey[ System.Windows.Forms.Keys.Left  ] = false;
		mKey[ System.Windows.Forms.Keys.Up    ] = false;
		mKey[ System.Windows.Forms.Keys.Right ] = false;
		mKey[ System.Windows.Forms.Keys.Down  ] = false;
		mKey[ System.Windows.Forms.Keys.L     ] = false;
		mKey[ System.Windows.Forms.Keys.N     ] = false;
		mKey[ System.Windows.Forms.Keys.Z     ] = false;
	}

	protected override void OnKeyDown( System.Windows.Forms.KeyEventArgs e )
	{
		mKey[ e.KeyCode ] = true;
		if( mKey[ System.Windows.Forms.Keys.N ] ){
			mNormal = !mNormal;
		}
	}

	protected override void OnKeyUp( System.Windows.Forms.KeyEventArgs e )
	{
		mKey[ e.KeyCode ] = false;
	}

	protected override void OnPaint( System.Windows.Forms.PaintEventArgs e )
	{
		if( !mInit ){
			mInit = true;
			init();
		}

		if( mKey[ System.Windows.Forms.Keys.L ] ){
			if( mKey[ System.Windows.Forms.Keys.Left  ] )	mLiDirH += 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Right ] )	mLiDirH -= 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Up    ] )	mLiDirV += 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Down  ] )	mLiDirV -= 1.0f / 16;
		}else if( mKey[ System.Windows.Forms.Keys.Z ] ){
			if( mKey[ System.Windows.Forms.Keys.Left  ] )	mZoom -= 1.0f;
			if( mKey[ System.Windows.Forms.Keys.Right ] )	mZoom += 1.0f;
			if( mKey[ System.Windows.Forms.Keys.Up    ] )	mZoom += 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Down  ] )	mZoom -= 1.0f / 16;
			if( mZoom < 0.1f ){
				mZoom = 0.1f;
			}
		}else{
			if( mKey[ System.Windows.Forms.Keys.Left  ] )	mAngleH += 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Right ] )	mAngleH -= 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Up    ] )	mAngleV += 1.0f / 16;
			if( mKey[ System.Windows.Forms.Keys.Down  ] )	mAngleV -= 1.0f / 16;
		}

		GL.ClearColor( 0, 0, 0, 1 );	//	R,G,B,A
		GL.Clear( GL.COLOR_BUFFER_BIT | GL.DEPTH_BUFFER_BIT );

		var		prg = mProgM;
		var		atr = mAtrbM;
		if( mNormal ){
			prg = mProgN;
			atr = mAtrbN;
		}
		prg.use();

		var		asp = (float)ClientSize.Width / ClientSize.Height;
		var		mvp = TUGL.Multiply(
		 TUGL.Ortho( -mZoom * asp, mZoom * asp, -mZoom, mZoom, -mZoom * 2, mZoom * 2 ),
		 TUGL.LookAt(
		   0.0f, -1.0f,  0.0f,
		   0.0f,  0.0f,  0.0f,
		   0.0f,  0.0f,  1.0f )
		);
		TUGL.RotateX( mAngleV, mvp );
		TUGL.RotateZ( mAngleH, mvp );
		GL.UniformMatrix4fv( prg.mUniLoc[ "mvpMatrix" ], 1, 0, mvp );

		if( mNormal ){
			float[]		ld = new float[]{
				(float)Math.Cos( mLiDirH ),
				(float)Math.Sin( mLiDirH ) * (float)Math.Cos( mLiDirV ),
				(float)Math.Sin( mLiDirV ),
			};
			GL.Uniform3fv( prg.mUniLoc[ "lightDir" ], 1, ld );
		}
		GL.Uniform4fv( prg.mUniLoc[ "gColor" ], 1, new float[]{ 1.0f, 1.0f, 1.0f, 1.0f } );

		mModel.draw( atr );

		mProgL.use();

		GL.UniformMatrix4fv( mProgL.mUniLoc[ "mvpMatrix" ], 1, 0, mvp );
		GL.Uniform4fv( mProgL.mUniLoc[ "gColor" ], 1, new float[]{ 1.0f, 1.0f, 1.0f, 1.0f } );
		mPriL.draw( mAtrbL );

		GL.SwapBuffers();	//	表裏画面を切り替え、描画内容を表示

		Task.Delay( 1 ).Wait();
		Invalidate();
	}

	protected override void OnSizeChanged( EventArgs e )
	{
		GL.Viewport( 0, 0, ClientSize.Width, ClientSize.Height );
	}

	void init()
	{
		GL.Enable( GL.DEPTH_TEST );
		GL.Enable( GL.CULL_FACE );
	}

	static void Main( string[] args )
	{
		System.Windows.Forms.Application.Run( new Program() );
	}
}
